Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
SHAKE128 Class Reference

SHAKE128 message digest. More...

Inheritance diagram for SHAKE128:

## Public Member Functions
| SHAKE128 ()
| Construct a SHAKE128 message digest. More...
| SHAKE128 (unsigned int outputSize)
| Construct a SHAKE128 message digest. More...
Public Member Functions inherited from SHAKE_Final< 128 >
| SHAKE_Final (unsigned int outputSize=DIGESTSIZE)
| Construct a SHAKE-X message digest. More...
unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from SHAKE
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | Restart ()
| Restart the hash. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Additional Inherited Members
Static Public Member Functions inherited from SHAKE_Final< 128 >
static std::string | StaticAlgorithmName ()
Static Public Attributes inherited from SHAKE_Final< 128 >
static const int | DIGESTSIZE
static const int | BLOCKSIZE

## Detailed Description

SHAKE128 message digest.

The library provides byte oriented SHAKE128 using F1600. FIPS 202 allows nearly unlimited output sizes, but Crypto++ limits the output size to `UINT_MAX` due underlying data types.

See also
  Keccak, SHA3, SHAKE256, FIPS 202, SHA-3 Standard: Permutation-Based Hash and Extendable-Output Functions

Since
  Crypto++ 8.1

Definition at line 107 of file shake.h.

## Constructor & Destructor Documentation

## ◆ SHAKE128() [1/2]

SHAKE128::SHAKE128 | ( |  | ) |
| inline

Construct a SHAKE128 message digest.

SHAKE128 and SHAKE256 don't need the output size in advance because the output size does not affect the digest. TruncatedFinal produces the correct digest for any output size. However, cSHAKE requires the output size in advance because the algoirthm uses output size as a parameter to the hash function.

Since
  Crypto++ 8.1

Definition at line 117 of file shake.h.

## ◆ SHAKE128() [2/2]

SHAKE128::SHAKE128 | ( | unsigned int | outputSize | ) |
| inline

Construct a SHAKE128 message digest.

SHAKE128 and SHAKE256 don't need the output size in advance because the output size does not affect the digest. TruncatedFinal produces the correct digest for any output size. However, cSHAKE requires the output size in advance because the algoirthm uses output size as a parameter to the hash function.

Since
  Crypto++ 8.1

Definition at line 126 of file shake.h.

The documentation for this class was generated from the following file:

- shake.h